/* CIN source file */

#include "extcode.h"
#include "hosttype.h"
#include <windows.h>
#include <windef.h>
#include <winnt.h>

extern BOOL WINAPI LogonUserA(LPSTR, LPSTR, LPSTR, DWORD, DWORD, PHANDLE);

MgErr CINRun(int32 *err, LStrHandle Username, LStrHandle Domain, LStrHandle Password)
	{

	HINSTANCE	hDLL;
	FARPROC	*addr;
	uInt32	hLogonUserA;
	int32	cinErr = 0;
	char	*UsernameCStr = NULL,
		*DomainCStr = NULL,
		*PasswordCStr = NULL;
	PHANDLE	phToken;
	BOOL	cb = FALSE;

	*err = 0;

// ***** get function
	hDLL = LoadLibrary ("advapi32.dll");
		if (hDLL < (HINSTANCE)HINSTANCE_ERROR) { *err = 1; goto out; }
	*(FARPROC*)&addr = GetProcAddress (hDLL,"LogonUserA");
		if (!addr) { *err = 2; goto out; }

// ***** convert LabVIEW-strings to C-strings
	if (!(UsernameCStr == (char *)DSNewPtr(*Username)+1)) {cinErr = mFullErr; goto out; }
	if (!(DomainCStr == (char *)DSNewPtr(*Domain)+1)) {cinErr = mFullErr; goto out; }
	if (!(PasswordCStr == (char *)DSNewPtr(*Password)+1)) {cinErr = mFullErr; goto out; }

	SPrintf(UsernameCStr, (CStr) "%P", *Username);
	SPrintf(DomainCStr, (CStr) "%P", *Domain);
	SPrintf(PasswordCStr, (CStr) "%P", *Password);

// ***** call Windows-API via handle (compiler stopps)
/*	hLogonUserA = GetIndirectFunctionHandle (addr, INDIR_PTR, INDIR_PTR, INDIR_PTR, INDIR_DWORD, INDIR_DWORD, INDIR_PTR, INDIR_ENDLIST);
	if (!hLogonUserA) { *err = 3; goto out; }
	cb = (BOOL)InvokeIndirektFunction(hLogonUserA, UsernameCStr, DomianCStr, PasswordCStr, 0x3, 0x0, phToken);
*/

// ***** call Windows-API via address (compiler: addr no function)
//	cb = (BOOL)addr(UsernameCStr, DomainCStr, PasswordCStr, 0x3, 0x0, phToken);

// ***** call Windows-API directly
	cb = (BOOL)LogonUserA(UsernameCStr, DomainCStr, PasswordCStr, 0x3, 0x0, phToken);

// ***** finish function
	out:
	if (UsernameCStr) DSDisposePtr(UsernameCStr);
	if (DomainCStr) DSDisposePtr(DomainCStr);
	if (PasswordCStr) DSDisposePtr(PasswordCStr);
	if (hDLL) FreeLibrary(hDLL);

	return cinErr;
	}